#include "S11nNodeListViewItem.h"

namespace s11n { namespace qt {

        void S11nNodeListViewItem::setText( int col, const QString & txt )
        {
                if( ! this->m_node ) return;
                typedef s11nlite::node_traits TR;
                switch( col )
                {
                  case 0 :
                          TR::name( *this->m_node, txt );
                          break;
                  case 1 :
                          TR::class_name( *this->m_node, txt );
                          break;
                  default:
                          this->QListViewItem::setText( col, txt );
                          break;
                };
        }

        void S11nNodeListViewItem::build_tree()
        {
                if( ! this->m_node ) return;
                typedef s11nlite::node_traits TR;
//                 for( int i = 0; i < 1; i++ )
//                 {
//                         this->setRenameEnabled(i,true);
//                 }

                this->QListViewItem::setText( 0, TR::name( *this->m_node ) );
                this->QListViewItem::setText( 1, TR::class_name( *this->m_node ) );

                typedef TR::child_list_type::iterator CHIT;
                CHIT bc = TR::children(*this->m_node).begin(),
                        ec = TR::children(*this->m_node).end();
                        

//                 S11nNodeListViewItem * chv = 0;
                for( ; ec != bc; ++bc )
                {
                        new S11nNodeListViewItem( *(*bc), this );
                }

        }



} } // namespace s11n::qt
